<?php
/*
Copyright (c) 2006, John Stevens
All rights reserved.
E-mail : john AT jstevens DOT com

Non-commercial redistribution and use, with or without modification, 
is permitted provided that the following conditions are
met:

    * Redistributions must retain the above copyright
      notice, this list of conditions and the following disclaimer.

    * The name of John Stevens may not
      be used to endorse or promote products derived from this
      software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
?>
<?php include_once("config_ini.php") ; ?>
<?php include_once("version.php") ; ?>
<?php include_once("tfheader_lib.php") ; ?>
<html>
<head>
  <title>ToppyWeb Files <?=$version?></title>
	<script src='files.js' type="text/javascript"></script>
	<script src='cookies.js' type="text/javascript"></script>

  <style type="text/css">
    @import "toppy-web.css";
  </style>
	
</head>

<body onload='files_init();' bgcolor='#003366'>

<?php include "links.php" ?>

<?PHP
  //print_r($_POST) ;
  //print_r($_COOKIE) ;
 	$set_action    = $_POST["set_action"];
 	$set_server    = stripslashes($_POST["set_server"]);
 	$set_filename  = stripslashes($_POST["set_filename"]);
 	$set_newname   = stripslashes($_POST["set_newname"]);
 	$set_newfolder = stripslashes($_POST["set_newfolder"]);
	$currentdir    = stripslashes($_POST["set_directory"]);
	if     ( array_key_exists("sort_key",$_COOKIE) )    { $set_file_sort = stripslashes($_COOKIE["sort_key"]) ; }
	elseif ( array_key_exists("set_file_sort",$_POST) ) { $set_file_sort = stripslashes($_POST["set_file_sort"]) ; }
	else                                                { $set_file_sort = strtolower($files_initial_sort) ; }
	//if ( array_key_exists("set_file_sort",$_POST) ) { $set_file_sort = stripslashes($_POST["set_file_sort"]) ; }
	//else                                            { $set_file_sort = strtolower($files_initial_sort) ; }
	
 	$fw_filename    = $_POST["fw_filename"];
 	$fw_newname     = $_POST["fw_newname"];
 	$fw_folder      = $_POST["fw_folder"];
 	$fw_server      = $_POST["fw_server"];
	
	$expand_server  = isset($_COOKIE["files_expand_server"]) ? $_COOKIE["files_expand_server"] : array() ;
	$expand_file    = isset($_COOKIE["files_expand_file"])   ? $_COOKIE["files_expand_file"]   : array() ;
	//print_r($expand_file) ;
	
	if ($demo_mode) { unset($set_action) ; }  // In demo mode discard any action requested
	
	if (!$force_cache)
	{
   // first see if any servers need waking
   foreach ($MyToppies as $servername)
   {	
    wake_server($servername) ;
   }
	}
	
	//echo "pre069 = " ;print_r($is_ftpdtopfield_pre069) ;
 ini_set("display_errors",0) ;
 switch ($set_action){
 case "Refresh":
 	break;

 case "Delete":
  if($ftp=ftp_connect($FTPaddress[$set_server],$FTPport[$set_server]))
  {
    ftp_login($ftp,$FTPuser[$set_server],$FTPpw[$set_server]);
	  ftp_chdir($ftp,$currentdir);
	    echo "<!-- Delete $currentdir/$set_filename -->\n" ;
	  ftp_delete($ftp,$set_filename);
    ftp_quit($ftp) ;
	}
 	break;

 case "Rename":
  $this_file_has_been_moved = array() ;
  if($ftp=ftp_connect($FTPaddress[$set_server],$FTPport[$set_server]))
  {
	  //echo "user/pw=".$FTPuser[$set_server]."/".$FTPpw[$set_server]."<br>\n";
    ftp_login($ftp,$FTPuser[$set_server],$FTPpw[$set_server]);
	  ftp_chdir($ftp,$currentdir);
 	  if ( $set_filename <> ($set_newfolder.$set_newname) )
 	  {
		  $i = 0 ;
			$tmpname = substr($set_newname,0,-4)."-#".substr($set_newname,-4) ;
			//echo "<!-- temp = $tmpname -->\n" ;
			while ($i<$rename_attempts) 
			{
		   if (ftp_size($ftp,$set_newfolder.$set_newname)<0) { break ; }
			 $i++ ;
			 $set_newname = substr_replace($tmpname,"$i",-5,1) ;
			 //echo "<!-- newname = $set_newname -->\n" ;
			}
			
	    echo "<!-- Rename $currentdir/$set_filename=>$set_newfolder$set_newname -->\n" ;
		  if (ftp_rename($ftp,$set_filename,$set_newfolder.$set_newname))
			{
			 $moved_file = array() ;
			 $moved_file["server"]   = $set_server ;
			 $moved_file["old_name"] = $currentdir."/".substr($set_filename,0,-4) ;
			 $moved_file["new_name"] = $set_newfolder.substr($set_newname,0,-4) ;
			 $this_file_has_been_moved[] = $moved_file ;
			 //print_r($this_file_has_been_moved) ;
			}
 	  }
    ftp_quit($ftp) ;
	}
	break;

 case "ForceWin":
  $set_folder = "/" ;
	$set_server = "" ;
  $this_file_has_been_moved = array() ;
  foreach ($fw_filename as $index => $set_filename)
	{
	 if (array_key_exists("$index",$fw_server)) { $set_server = stripslashes($fw_server[$index]); }
	 if (array_key_exists("$index",$fw_folder)) { $set_folder = stripslashes($fw_folder[$index]); }
	 $set_newname = stripslashes($fw_newname[$index]) ;
	 $set_filename = stripslashes($set_filename) ;	
	 //echo "Rename $set_folder/$set_filename => $set_newname<br>\n" ;
   if($ftp=ftp_connect($FTPaddress[$set_server],$FTPport[$set_server]))
   {
    ftp_login($ftp,$FTPuser[$set_server],$FTPpw[$set_server]);
	  ftp_chdir($ftp,$currentdir);
	  ftp_chdir($ftp,$set_folder);
 	  if ( $set_filename <> $set_newname )
 	  {
		  $i = 0 ;
			$tmpname = substr($set_newname,0,-4)."-#".substr($set_newname,-4) ;
			//echo "<!-- temp = $tmpname -->\n" ;
			while ($i<$rename_attempts) 
			{
		   if (ftp_size($ftp,$set_newfolder.$set_newname)<0) { break ; }
			 $i++ ;
			 $set_newname = substr_replace($tmpname,"$i",-5,1) ;
			 //echo "<!-- newname = $set_newname -->\n" ;
			} 
	   //echo "Rename $set_filename=>$set_newname<br>\n" ;
	 	 //ftp_rename($ftp,$set_folder."/".$set_filename,$set_folder."/".$set_newname);
	 	 if (ftp_rename($ftp,$set_filename,$set_newname))
		 {
			 $moved_file = array() ;
			 $moved_file["server"]   = $set_server ;
			 $moved_file["old_name"] = $set_folder."/".substr($set_filename,0,-4) ;
			 $moved_file["new_name"] = $set_folder."/".substr($set_newname,0,-4) ;
			 $this_file_has_been_moved[] = $moved_file ;
		 }
 	  }
	  ftp_close($ftp) ;
	 }
	}
	break;
 case "Home":
 default:
	break;
 }
 ini_set("display_errors",1) ;
 

 
// build the list of files, etc for display 
include "files_get_list.php" ;



if($extended_desc)
{ 
 $full_extended_cache = tfheader_build_cache($full_extended_list,15) ;
 //echo "Full extended cache =>";print_r($full_extended_cache) ;
}
//print_r($expand_server) ;
//print_r($TFexpandServer);
//print_r($TFexpandFolders);
echo "<script language='JavaScript' type='text/javascript'>\n";
echo "<!--\n";
foreach($expand_server as $key => $value)
{
 echo "SetCookie( 'files_expand_server[$key]', '$value') ;\n" ;
}
foreach($expand_file as $key => $value)
{
 echo "SetCookie( 'files_expand_file[$key]', '$value') ;\n" ;
}
echo "//-->\n";
echo "</script>\n";
?>
<script language='JavaScript' type="text/javascript">
<!--
openImage       = new Image(16,16) ;
closedImage     = new Image(16,16) ;
openImage.src   = "minus.gif" ;
closedImage.src = "plus.gif" ;
//-->
</script>

<div id="div_list" style="z-index: 4; width: 800px;">
<form name="form_list" id="form_list" method="POST" action="<?=$_SERVER['SCRIPT_NAME']?>">

<input type="hidden" name="set_action" value="none">
<input type="hidden" name="set_filename" value="">
<input type="hidden" name="set_directory" value="">
<input type="hidden" name="set_server" value="">

<table class='table_outer' cellspacing='2'>
 <tr>
  <td>
   <table class='table_server' id='table_server_0' cellspacing='0'>
    <tr class='server_row'>
     <td class='fcol_header'>
      Topfield REC files&nbsp;
      <input type='button' value='Refresh the display' onClick='click_refresh(this.form);'>&nbsp;&nbsp;
      <input type='button' name='fw_button' id='fw_button' value='Make filenames Windows compliant?' onClick='click_forcewin();' style='visibility: visible;'>
     </td>
    </tr>
    <tr>
		 <td>
     <div id='div_server_0' style='display:block'>
      <table class='table_server_content' cellspacing='0'>
       <tr>
	      <td colspan=99>
         <table class='table_folder' id='table_folder_0_0' cellspacing='0'>
          <tr id='folder0' class='directory_row' style='display:table-row;'>
	         <td class='fcol_sort'><input type='button' name='sort_by_name' id='sort_by_name' value='Sort files by Name' onClick="click_sort('name');return false;"></td>
	         <td class='fcol_sort'><input type='button' name='sort_by_date' id='sort_by_date' value='Sort files by Recorded Date' onClick="click_sort('date');return false;"></td>
	        </tr>
	       </table>
        </td>
       </tr>
      </table>
		 </div>
     </td>
    </tr>
   </table>
<?PHP
$servernum = 0;
foreach ($serverlist as $servername)
{
  $servernum += 1 ;
  $server_nums[$servername] = $servernum ;
  $folderfiles      = $serverfiles[$servername] ;
  $foldersizes      = $serversizes[$servername] ;
  $folderlist       = $serverfolders[$servername] ;
  $rec1             = $serverRec1[$servername] ;
  $rec2             = $serverRec2[$servername] ;
  $play             = $serverPlay[$servername] ;
  $file_active_rec  = $server_active_rec[$servername] ;
  $file_active_play = $server_active_play[$servername] ;
  $file_is_rec      = $server_is_rec[$servername] ;
  $file_extn        = $server_extn[$servername] ;
	$server_totsize   = is_array($foldersizes) ? array_sum($foldersizes) : 0 ;
	$foldercache      = $server_foldercache[$servername] ;
	
  if(!is_array($folderfiles)) { $folderfiles = array() ; }
	
	if(substr($expand_server[$servername],0,1)=="y")
	{
	$is_expand = "block" ;
	$image = "minus.gif" ;
	}
	else
	{
	$is_expand = "none" ;
	$image = "plus.gif" ;
	}
	
	if($server_error[$servername] && !$use_cache[$servername])
	{
?>
<tr><td>
<table class='table_server' id='table_server_<?=$servernum?>' cellspacing='0'>
<tr class='server_row'>
<td class='fcol_first'></td>
<td class='fcol_server' colspan='2'><?=$servername?></td>
<td class='fcol_error' colspan='5'><?=$server_error[$servername]?></td>
</tr>

<tr><td colspan=99>
<div id='div_server_<?=$servernum?>' style='display:<?=$is_expand?>;'>
<table class='table_server_content' cellspacing='0'>
<?PHP
	}
	else
	{
?>
<tr><td>
<table class='table_server' id='table_server_<?=$servernum?>' cellspacing='0'>
<tr class='server_row' onMouseOver='highlight_server(this,<?=$servernum?>);' onMouseOut='lowlight_server(this,<?=$servernum?>);' onClick='click_server(this,<?=$servernum?>,"<?=$servername?>");'>
<td class='fcol_first'><img id='img_server_<?=$servernum?>' src='<?=$image?>' alt=''></td>
<td class='fcol_server'><?=($servername)?></td>
<!--<td class='fcol_server'><?=($servername.is_true($use_cache[$servername],' (Using cache)',''))?></td>-->
<td class='fcol_size'><?=format_size($server_totsize,0)?></td>
<td class='fcol_space'>&nbsp;</td>
<td class='fcol_date' colspan='2'><?=(count($foldersizes)." Folders")?></td>
<td class='fcol_server_last'><?=(number_format(100*($server_totsize/$TFhdd[$servername]),1,".",",")."% of ".format_size($TFhdd[$servername],0)." used")?></td>
</tr>
<?PHP
 if($use_cache[$servername] and !$demo_mode)
 {
  echo "<tr><td colspan=7 align='center'><div class='fcol_warn'>Using cache (".$server_error[$servername].")</div></td></tr>\n" ;
 }
?>
<tr><td colspan=7>
<div style='width:810px; height:0px; overflow:hidden;'><!-- --></div>
<div id='div_server_<?=$servernum?>' style='display:<?=$is_expand?>;'>
<table class='table_server_content' cellspacing='0'>
<?PHP
  }
	
	$tot_size = 0.0;
	$files = array() ;
	$filenums = array() ;
	$foldernums = array() ;
	$filenames = array() ;
	$foldernames = array() ;
	$filenum = 0 ;
	$foldernum = 0 ;
	ksort($folderfiles) ;
 foreach ($folderfiles as $foldername => $files )
 {
  $foldernum += 1;
	$foldernums[$foldername] = $foldernum ;
	$foldernames[$foldernum] = $foldername ;
	$sizeX = format_size($foldersizes[$foldername],"Empty") ;
	$folder_id = $servernum."_".$foldernum ;
	
	if(substr($expand_server[$servername],$foldernum,1)=="y")
	{
	$is_expand = "block" ;
	$image = "minus.gif" ;
	}
	else
	{
	$is_expand = "none" ;
	$image = "plus.gif" ;
	}
	
  echo "<tr><td>\n";
  echo "<table class='table_folder' id='table_folder_".$folder_id."' cellspacing='0'>\n";
	if(count($files)==0)
	{
   echo "<tr id='folder_$folder_id' class='directory_row' style='display:table-row;'>\n";
	 echo "<td class='fcol_first'></td>\n";
	}
	else
	{
	 echo "<tr id='folder_$folder_id' class='directory_row' style='display:table-row;' onMouseOver='highlight_folder(this,$servernum,$foldernum);' onMouseOut='lowlight_folder(this,$servernum,$foldernum);' onClick='click_folder(this,$servernum,$foldernum,\"$servername\");'>\n";
	 echo "<td class='fcol_first'><img id='img_folder_$folder_id' src='$image' alt=''></td>\n";
	}
	if($foldercache[$foldername]) {	echo "<td class='fcol_folder_name'>$foldername (using cache)</td>\n"; }
	else                          {	echo "<td class='fcol_folder_name'>$foldername</td>\n"; }
	echo "<td class='fcol_space'></td>\n";
	echo "<td class='fcol_size'>$sizeX</td>\n";
	echo "<td class='fcol_space'></td>\n";
	echo "<td class='fcol_date' colspan=2>".count($files)." files</td>\n";
	echo "<td class='file_directory'>".(number_format(100*($foldersizes[$foldername]/$hdd_size),1,".",",")."% used")."</td>\n";
	echo "</tr>\n" ;
	
  echo "<tr><td colspan=8>\n";
  echo "<div style='display:block; width:797px; height:0px;'><!-- --></div>\n";
  echo "<div id='div_folder_$folder_id' style='display:$is_expand;'>\n";
	if(count($files)>0)
	{
   echo "<table class='table_folder_content' cellspacing='0'>\n";

	 foreach ($files as $key => $line)
	 {
	  list($sortkey,$index) = explode("\t",$key) ;
	  list($rights,$x,$u1,$u2,$size,$month,$day,$time,$name) = sscanf($line,"%s %s %s %s %f %s %s %s %s");
	  if ($index=="..") {continue; }
    $filenum += 1;
	  $filenums[$name] = $foldernum ;
	  $filenames[$foldernum] = $name ;
	  $tot_size += $size ;
	  $sizeX = format_size($size,0) ;
		$event = get_extended_event($full_extended_cache,$servername,$foldername,$index) ;
		$file_id = $folder_id."_".$filenum ;
	
	  if($expand_file[$servername.$foldername."/".$index]=="y")
	  {
	   $is_expand = "block" ;
	   $image = "minus.gif" ;
	  }
	  else
	  {
	   $is_expand = "none" ;
	   $image = "plus.gif" ;
	  }
	  echo "\n";
		if(is_array($event))
		{
	   echo "<tr id='file_$file_id' class='file_row' style='display:table-row;' onMouseOver='highlight_file(this,$servernum,$foldernum,$filenum);' onMouseOut='lowlight_file(this,$servernum,$foldernum,$filenum);' onClick='click_file(this,$servernum,$foldernum,$filenum,\"".htmlentities($servername.$foldername,ENT_QUOTES)."/".htmlentities($index,ENT_QUOTES)."\");'>\n";
	   echo "<td class='fcol_first' align='center'><img id='img_file_$file_id' src='$image' alt='' height='10' width='10'></td>\n" ;
		}
		else
		{
	   echo "<tr id='file_$file_id' class='file_row' style='display:table-row;'>\n";
	   echo "<td class='fcol_first'>&nbsp;</td>\n" ;
		}
	  echo "<td class='fcol_name'><div class='div_filename'>".$index."</div></td>\n";
	  echo "<td class='fcol_space'>&nbsp;</td>\n"; 
	  echo "<td class='fcol_size'>$sizeX</td>\n";
	  echo "<td class='fcol_space'>&nbsp;</td>\n"; 
	  echo "<td class='fcol_date1'>$month $day</td>\n";
	  echo "<td class='fcol_date2'>$time</td>\n" ;
	  if( $file_is_rec[$index] )
	  {
	   //if($size>0) 
	   if($file_active_rec[$index]) 
	   {
	    echo "<td class='file_recording'><b>Recording</b></td></tr>\n"; 
	   }
	   elseif($file_active_play[$index])
	   {
	    echo "<td class='file_playback'><b>Playback</b></td></tr>\n"; 
	   }
	   elseif( ($use_cache[$servername] or $foldercache[$foldername]) and !$demo_mode)
		 {
	    echo "<td class='file_cached'>Actions disabled on cache</td></tr>\n";
		 }
		 else 
	   { 
	 	  echo "<td class='fcol_last'>\n";
		  echo "<input class='button_file' type='button' value='Delete' onClick='click_delete(this.form,\"".htmlentities($index,ENT_QUOTES)."\",\"".$file_extn[$index]."\",\"".htmlentities($foldername,ENT_QUOTES)."\",\"$servername\");'>" ;
	 	  echo "<input class='button_file' type='button' name='rename' value='Rename/Move' onclick='click_rename($servernum,\"".htmlentities($index,ENT_QUOTES)."\",\"".$file_extn[$index]."\",\"".htmlentities($foldername,ENT_QUOTES)."\",\"$servername\");'>\n";
		  echo "</td>\n";
	   }
		 if(is_array($event))
		 {
		  echo "<tr class='file_row' id='row_extdesc_$file_id'><td colspan=8>\n" ;
			echo "<div class='div_extended' id='div_extdesc_$file_id' style='display:$is_expand;'>\n" ;
			 echo "<b>".$event["ServiceName"].": ".$event["EventName"]." ".$event["EventDescription"]."</b><br>\n" ;
			 echo "<i>".$event["StartDate"]." - ".$event["EndDate"]." (".$event["EventDuration"]." minutes)</i><br>\n" ;
			 echo "".$event["ExtendedText"]."<br>\n" ;
			 echo "<i><font color='red'>Recording length: ".$event["RecordingDuration"]." minutes</font></i>\n" ;
			echo "</div>\n" ;
			echo "</td></tr>\n" ;
		 }
	  }
	  else
	  {
	   echo "<td class='file_not_rec'><b>Not a REC file</b></td>\n";
	  }
	  echo "</tr>\n"; 
	 }
   echo "\n</table>\n";  // end of folder content table
	}
  echo "</div>\n";
  echo "</td></tr>\n";
  echo "</table>\n";  // end of folder table
 }	
 echo "</td></tr>\n";
 echo "</table>\n";  // end of server content table
 echo "</div>\n";
 echo "</td></tr>\n";
 echo "</table>\n";  // end of server table
 echo "</td></tr>\n";
}
echo "</table>\n";
?>
<input type="hidden" name="set_file_sort" value="<?=$set_file_sort?>">
</form>
</div>



<?PHP foreach($serverlist as $servername){?>
	
<div id="div_rename_<?=$server_nums[$servername]?>" style="visibility: hidden; position:absolute; top:330px; left:20px; z-index: 4; width: 600px; height: 200px; background-color:white; border: 5px double black;" >

<form name="form-rename-<?=$server_nums[$servername]?>" id="form_rename_<?=$server_nums[$servername]?>" method="POST" action="<?=$_SERVER['SCRIPT_NAME']?>">
<input type="hidden" name="set_filename" value="">
<input type="hidden" name="set_action" value="">
<input type="hidden" name="set_directory" value="">
<input type="hidden" name="set_server" value="">
<input type="hidden" name="set_file_sort" value="<?=$set_file_sort?>">

<table width="90%" align="center">

<tr><td colspan=2></td><td>&nbsp;</td></tr>
<tr bgcolor="pink"><td>&nbsp;</td><td>Rename the recorded file</td><td align="right">Force Windows Name <input type="checkbox" name="forcewinname" onclick="forcewin(this.form)" <?=is_checked($force_win_names)?> /></td></tr>
<tr><td align="right">Toppy:</td><td colspan=2><div id="div_servername_<?=$server_nums[$servername]?>" style="width: 400px;">server</div></td></tr>
<tr><td align="right">Old:</td><td colspan=2><div id="div_oldname_<?=$server_nums[$servername]?>" style="width: 400px;">This is some text</div></td></tr>
<tr><td align="right">New:</td><td colspan=2><input name="set_newname" type="text" size=80 value="new name"  onchange="forcewin(this.form)">&nbsp;(.rec)</td></tr>
<tr><td align="right">Move to:</td><td colspan=2><select name="set_newfolder"><?=select_folder($serverfiles[$servername])?></select></td></tr>

<tr><td colspan=3><input type="button" name="rename" value="Rename and/or Move the recorded file" onclick='click_actionrename(this.form)'>
				<input type="button" name="cancel" value="Cancel" onclick='document.getElementById("div_rename_<?=$server_nums[$servername]?>").style.visibility = "hidden"'></td></tr>

</table>

</form>

</div>


	
<?PHP } ?>






<div id="div_forcewin" style="visibility: hidden; display: none; position:absolute; top:80px; left:20px; z-index: 5; width: 800px; background-color:white; border: 5px double black;" >

<form name="form_forcewin" id="form_forcewin" method="POST" action="<?=$_SERVER['SCRIPT_NAME']?>">
<input type="hidden" name="set_filename" value="">
<input type="hidden" name="set_action" value="">
<input type="hidden" name="set_file_sort" value="<?=$set_file_sort?>">

<table width="90%" align="center">
<tr><td colspan='3'>&nbsp;</td></tr>
<tr bgcolor="pink"><th>&nbsp;</th><th>Current name</th><th>Windows Compliant name</th></tr>
<?PHP 
 $folderhead = "" ;
 $winfoldernum = 0 ;
 $winfilenum = 0 ;
 foreach ($serverlist as $servername)
 {
  $folderfiles      = $serverfiles[$servername] ;
  $foldersizes      = $serversizes[$servername] ;
  $folderlist       = $serverfolders[$servername] ;
  $rec1             = $serverRec1[$servername] ;
  $rec2             = $serverRec2[$servername] ;
  $play             = $serverPlay[$servername] ;
  $file_active_rec  = $server_active_rec[$servername] ;
  $file_active_play = $server_active_play[$servername] ;
  $file_is_rec      = $server_is_rec[$servername] ;
  $file_extn        = $server_extn[$servername] ;
	
  $serverhead = "<tr class='server_row'><td colspan='2' class='server_row'>$servername</td>\n" ;
  foreach ($folderfiles as $foldername => $files )
  {
   $winfoldernum += 1;
	 //$foldernums[$foldername] = $foldernum ;
	 //$foldernames[$foldernum] = $foldername ;
   $folderhead = "<tr class='directory_row'><td><img src='folder_movie.gif' alt=''></td><td>$foldername</td>\n" ;
	 foreach ($files as $key => $line)
	 {
	  list($sortkey,$index) = explode("\t",$key) ;
	  list($rights,$x,$u1,$u2,$size,$month,$day,$time,$name) = sscanf($line,"%s %s %s %s %f %s %s %s %s");
	  if ($index=="..") {continue; }
	  $winname = win_compliant($index) ;
		//echo "winname=$winname\n";
		//echo "curname=$index\n";
		//echo "isrec=".$file_is_rec[$index]."\n";
		//echo "active=".$file_active_rec[$index]."\n";
		//echo "play=".$file_active_play[$index]."\n";
	  //$filenums[$name] = $foldernum ;
	  //$filenames[$foldernum] = $name ;
	  if($index<>$winname && $file_is_rec[$index] && !$file_active_rec[$index] && !$file_active_play[$index])
	  {
     $winfilenum += 1;
		 //echo "winfilenum=$winfilenum\n";
		 if($serverhead<>"") 
		 {
		  echo $serverhead ;
		  $serverhead = "" ;
      echo "<td><input type='hidden' name='fw_server[$winfilenum]' value='".htmlentities($servername,ENT_QUOTES)."'></td></tr>\n";
		 }
		 if($folderhead<>"") 
		 {
		  echo $folderhead ;
		  $folderhead = "" ;
      echo "<td><input type='hidden' name='fw_folder[$winfilenum]' value='".htmlentities($foldername,ENT_QUOTES)."'></td></tr>\n";
		 }
	   echo "<tr class='file_row'>\n" ;
	   echo "<td>\n" ;
     echo "<input type='hidden' name='fw_filename[$winfilenum]' value='".htmlentities($index,ENT_QUOTES).$file_extn[$index]."'>\n";
     echo "<input type='hidden' name='fw_newname[$winfilenum]' value='".htmlentities($winname,ENT_QUOTES).".rec'>\n";
	   echo "</td>\n" ;
	   echo "<td>".$index."</td><td>$winname</td></tr>\n"; 
	  }
	 }
  }	
 }
 //echo "<input type='hidden' name='fw_count' id='fw_count' value='$winfilenum'>\n";
?>
<tr><td colspan=3><input type="button" name="forcewin" value="Apply the name changes" onclick='click_actionforcewin(this.form)'>
				<input type="button" name="cancel" value="Cancel" onclick='document.getElementById("div_forcewin").style.visibility = "hidden"'></td></tr>

</table>

 <input type='hidden' name='fw_count' id='fw_count' value='<?=$winfilenum?>'>
</form>

</div>

<form name="form_files" id="form_files" method="post" action="files.php" style="display:none;">
 <input type="hidden" name="set_file_sort" value="<?=$set_file_sort?>" />
</form>

</body>
</html>

<?PHP 
function format_size($size,$zerobytes=0)
{
	$sizeK = $size/1024;
	$sizeM = $sizeK/1024;
	$sizeG = $sizeM/1024;
	//echo "Size = $size | $sizeK | $sizeM | $sizeG <br>\n";
	//echo "Size = $size | ".($sizeK > 1.0)." | ".($sizeM > 1.0)." | ".($sizeG > 1.0)." <br>\n";
	if($size == 0) { $sizeX = $zerobytes; }
	else if($sizeG > 1.0) {$sizeX = number_format($sizeG,1,".",",")."GB"; }
	else if($sizeM > 1.0) {$sizeX = number_format($sizeM,1,".",",")."MB"; }
	else if($sizeK > 1.0) {$sizeX = number_format($sizeK,1,".",",")."KB"; }
	else {$sizeX = $size; }
	return $sizeX ;
}

function select_folder($folderfiles)
{
 //global $folderfiles ;
 
 echo "<option value='' selected='selected'>Do not move</option>\n" ;
 foreach ($folderfiles as $foldername => $files)
 {
  echo "<option value='$foldername/'>$foldername</option>\n" ;
 }
}

function server_connect($servername)
{
 global $FTPaddress,$FTPport,$FTPuser,$FTPpw ;
 
 if ($servername=="Local")
 {
  return true ;
 }
 else 
 {
  if(($ftp=ftp_connect($FTPaddress[$servername],$FTPport[$servername]))) 
  { 
   if (ftp_login($ftp,$FTPuser[$servername],$FTPpw[$servername]))
	 {
	  return true ;
	 }
	 else
	 {
	 }
  }
	else
	{
	}
 }
 return false ;
}

?>
